#include "StdAfx.h"
#include "IOCPModel.h"
//#include "MainDlg.h"

// ÿһϲٸ߳(Ϊ޶ȵܣĵ)
#define WORKER_THREADS_PER_PROCESSOR 2
// ͬʱͶݵAccept(Ҫʵʵ)
#define MAX_POST_ACCEPT              10
// ݸWorker̵߳˳ź
#define EXIT_CODE                    NULL


// ͷָ;Դĺ

// ͷָ
#define RELEASE(x)                      {if(x != NULL ){delete x;x=NULL;}}
// ͷž
#define RELEASE_HANDLE(x)               {if(x != NULL && x!=INVALID_HANDLE_VALUE){ CloseHandle(x);x = NULL;}}
// ͷSocket
#define RELEASE_SOCKET(x)               {if(x !=INVALID_SOCKET) { closesocket(x);x=INVALID_SOCKET;}}



CIOCPModel::CIOCPModel(void):
							m_nThreads(0),
							m_hShutdownEvent(NULL),
							m_hIOCompletionPort(NULL),
							m_phWorkerThreads(NULL),
							m_strIP(DEFAULT_IP),
							m_nPort(DEFAULT_PORT),
							m_pMain(NULL),
							m_lpfnAcceptEx( NULL ),
							m_pListenContext( NULL )
{
}


CIOCPModel::~CIOCPModel(void)
{
	// ȷԴͷ
	this->Stop();
}




///////////////////////////////////////////////////////////////////
// ̣߳  ΪIOCPĹ߳
//         Ҳÿɶ˿ϳݰͽ֮ȡд߳
///////////////////////////////////////////////////////////////////

DWORD WINAPI CIOCPModel::_WorkerThread(LPVOID lpParam)
{    
	THREADPARAMS_WORKER* pParam = (THREADPARAMS_WORKER*)lpParam;
	CIOCPModel* pIOCPModel = (CIOCPModel*)pParam->pIOCPModel;
	int nThreadNo = (int)pParam->nThreadNo;

	pIOCPModel->_ShowMessage(_T("߳ID: %d."),nThreadNo);

	OVERLAPPED           *pOverlapped = NULL;
	PER_SOCKET_CONTEXT   *pSocketContext = NULL;
	DWORD                dwBytesTransfered = 0;

	// ѭ֪յShutdownϢΪֹ
	while (WAIT_OBJECT_0 != WaitForSingleObject(pIOCPModel->m_hShutdownEvent, 0))
	{
		BOOL bReturn = GetQueuedCompletionStatus(
			pIOCPModel->m_hIOCompletionPort,
			&dwBytesTransfered,
			(PULONG_PTR)&pSocketContext,
			&pOverlapped,
			INFINITE);

		// յ˳־ֱ˳
		if ( EXIT_CODE==(DWORD)pSocketContext )
		{
			break;
		}

		// жǷ˴
		if( !bReturn )  
		{  
			DWORD dwErr = GetLastError();

			// ʾһʾϢ
			if( !pIOCPModel->HandleError( pSocketContext,dwErr ) )
			{
				break;
			}

			continue;  
		}  
		else  
		{  	
			// ȡĲ
			PER_IO_CONTEXT* pIoContext = CONTAINING_RECORD(pOverlapped, PER_IO_CONTEXT, m_Overlapped);  

			// жǷпͻ˶Ͽ
			if((0 == dwBytesTransfered) && ( RECV_POSTED==pIoContext->m_OpType || SEND_POSTED==pIoContext->m_OpType))  
			{  
				pIOCPModel->_ShowMessage( _T("ͻ %s:%d Ͽ."),inet_ntoa(pSocketContext->m_ClientAddr.sin_addr), ntohs(pSocketContext->m_ClientAddr.sin_port) );

				// ͷŵӦԴ
				pIOCPModel->_RemoveContext( pSocketContext );

 				continue;  
			}  
			else
			{
				switch( pIoContext->m_OpType )  
				{  
					 // Accept  
				case ACCEPT_POSTED:
					{ 

						// ΪӴɶԣרŵ_DoAcceptд
						pIOCPModel->_DoAccpet( pSocketContext, pIoContext );						
						

					}
					break;

					// RECV
				case RECV_POSTED:
					{
						// ΪӴɶԣרŵ_DoRecvд
						pIOCPModel->_DoRecv( pSocketContext,pIoContext );
					}
					break;

					// SEND
					// ԹдˣҪ̫ˣ⣬SendһЩ
				case SEND_POSTED:
					{

					}
					break;
				default:
					// Ӧִе
					TRACE(_T("_WorkThreadе pIoContext->m_OpType 쳣.\n"));
					break;
				} //switch
			}//if
		}//if

	}//while

	TRACE(_T("߳ %d ˳.\n"),nThreadNo);

	// ͷ̲߳
	RELEASE(lpParam);	

	return 0;
}



//====================================================================================
//
//				    ϵͳʼֹ
//
//====================================================================================




////////////////////////////////////////////////////////////////////
// ʼWinSock 2.2
bool CIOCPModel::LoadSocketLib()
{    
	WSADATA wsaData;
	int nResult;
	nResult = WSAStartup(MAKEWORD(2,2), &wsaData);
	// (һ㶼ܳ)
	if (NO_ERROR != nResult)
	{
		this->_ShowMessage(_T("ʼWinSock 2.2ʧܣ\n"));
		return false; 
	}

	return true;
}

//////////////////////////////////////////////////////////////////
//	
bool CIOCPModel::Start(unsigned int port)
{
	// ʼ̻߳
	InitializeCriticalSection(&m_csContextList);

	// ϵͳ˳¼֪ͨ
	m_hShutdownEvent = CreateEvent(NULL, TRUE, FALSE, NULL);

	// ʼIOCP
	if (false == _InitializeIOCP())
	{
		this->_ShowMessage(_T("ʼIOCPʧܣ\n"));
		return false;
	}
	else
	{
		this->_ShowMessage(_T("\nIOCPʼ\n."));
	}

	// ʼSocket
	if( false==_InitializeListenSocket(port) )
	{
		this->_ShowMessage(_T("Listen Socketʼʧܣ\n"));
		this->_DeInitialize();
		return false;
	}
	else
	{
		this->_ShowMessage(_T("Listen Socketʼ."));
	}

	this->_ShowMessage(_T("ϵͳ׼Ⱥ....\n"));

	return true;
}


////////////////////////////////////////////////////////////////////
//	ʼϵͳ˳Ϣ˳ɶ˿ں߳Դ
void CIOCPModel::Stop()
{
	if( m_pListenContext!=NULL && m_pListenContext->m_Socket!=INVALID_SOCKET )
	{
		// رϢ֪ͨ
		SetEvent(m_hShutdownEvent);

		for (int i = 0; i < m_nThreads; i++)
		{
			// ֪ͨеɶ˿ڲ˳
			PostQueuedCompletionStatus(m_hIOCompletionPort, 0, (DWORD)EXIT_CODE, NULL);
		}

		// ȴеĿͻԴ˳
		WaitForMultipleObjects(m_nThreads, m_phWorkerThreads, TRUE, INFINITE);

		// ͻбϢ
		this->_ClearContextList();

		// ͷԴ
		this->_DeInitialize();

		this->_ShowMessage(_T("ֹͣ\n"));
	}	
}


////////////////////////////////
// ʼɶ˿
bool CIOCPModel::_InitializeIOCP()
{
	// һɶ˿
	m_hIOCompletionPort = CreateIoCompletionPort(INVALID_HANDLE_VALUE, NULL, 0, 0 );

	if ( NULL == m_hIOCompletionPort)
	{
		this->_ShowMessage(_T("ɶ˿ʧܣ: %d!\n"), WSAGetLastError());
		return false;
	}

	// ݱеĴӦ߳
	m_nThreads = WORKER_THREADS_PER_PROCESSOR * _GetNoOfProcessors();
	
	// Ϊ̳߳ʼ
	m_phWorkerThreads = new HANDLE[m_nThreads];
	
	// ݼ߳
	DWORD nThreadID;
	for (int i = 0; i < m_nThreads; i++)
	{
		THREADPARAMS_WORKER* pThreadParams = new THREADPARAMS_WORKER;
		pThreadParams->pIOCPModel = this;
		pThreadParams->nThreadNo  = i+1;
		m_phWorkerThreads[i] = ::CreateThread(0, 0, _WorkerThread, (void *)pThreadParams, 0, &nThreadID);
	}

	TRACE("  _WorkerThread %d .\n", m_nThreads );

	return true;
}


/////////////////////////////////////////////////////////////////
// ʼSocket
bool CIOCPModel::_InitializeListenSocket(unsigned int port)
{
	// AcceptEx  GetAcceptExSockaddrs GUIDڵָ
	GUID GuidAcceptEx = WSAID_ACCEPTEX;  
	GUID GuidGetAcceptExSockAddrs = WSAID_GETACCEPTEXSOCKADDRS; 

	// ַϢڰSocket
	struct sockaddr_in ServerAddress;

	// ڼSocketϢ
	m_pListenContext = new PER_SOCKET_CONTEXT;

	// ҪʹصIOʹWSASocketSocketſ֧صIO
	m_pListenContext->m_Socket = WSASocket(AF_INET, SOCK_STREAM, 0, NULL, 0, WSA_FLAG_OVERLAPPED);
	if (INVALID_SOCKET == m_pListenContext->m_Socket) 
	{
		this->_ShowMessage(_T("ʼSocketʧܣ: %d.\n"), WSAGetLastError());
		return false;
	}
	else
	{
		TRACE("WSASocket() .\n");
	}

	// Listen Socketɶ˿
	if( NULL== CreateIoCompletionPort( (HANDLE)m_pListenContext->m_Socket, m_hIOCompletionPort,(DWORD)m_pListenContext, 0))  
	{  
		this->_ShowMessage(_T(" Listen Socketɶ˿ʧܣ: %d/n"), WSAGetLastError());  
		RELEASE_SOCKET( m_pListenContext->m_Socket );
		return false;
	}
	else
	{
		TRACE("Listen Socketɶ˿ .\n");
	}

	// ַϢ
	ZeroMemory((char *)&ServerAddress, sizeof(ServerAddress));
	ServerAddress.sin_family = AF_INET;
	// ԰κοõIPַ߰һָIPַ 
	ServerAddress.sin_addr.s_addr = htonl(INADDR_ANY);                      
	//ServerAddress.sin_addr.s_addr = inet_addr(m_strIP.GetString());         
	ServerAddress.sin_port = htons(port);                          

	// 󶨵ַͶ˿
	if (SOCKET_ERROR == bind(m_pListenContext->m_Socket, (struct sockaddr *) &ServerAddress, sizeof(ServerAddress))) 
	{
		this->_ShowMessage(_T("bind()ִд! : %d/n"), WSAGetLastError());  
		return false;
	}
	else
	{
		TRACE("bind() .\n");
	}

	// ʼм
	if (SOCKET_ERROR == listen(m_pListenContext->m_Socket,SOMAXCONN))
	{
		this->_ShowMessage(_T("Listen()ִгִ; : %d/n"), WSAGetLastError());  
		return false;
	}
	else
	{
		TRACE("Listen() .\n");
	}

	// ʹAcceptExΪWinSock2淶֮΢ṩչ
	// Ҫȡһºָ룬
	// ȡAcceptExָ
	DWORD dwBytes = 0;  
	if(SOCKET_ERROR == WSAIoctl(
		m_pListenContext->m_Socket, 
		SIO_GET_EXTENSION_FUNCTION_POINTER, 
		&GuidAcceptEx, 
		sizeof(GuidAcceptEx), 
		&m_lpfnAcceptEx, 
		sizeof(m_lpfnAcceptEx), 
		&dwBytes, 
		NULL, 
		NULL))  
	{  
		this->_ShowMessage(_T("WSAIoctl δܻȡAcceptExָ롣: %d\n"), WSAGetLastError()); 
		this->_DeInitialize();
		return false;  
	}  

	// ȡGetAcceptExSockAddrsָ룬Ҳͬ
	if(SOCKET_ERROR == WSAIoctl(
		m_pListenContext->m_Socket, 
		SIO_GET_EXTENSION_FUNCTION_POINTER, 
		&GuidGetAcceptExSockAddrs,
		sizeof(GuidGetAcceptExSockAddrs), 
		&m_lpfnGetAcceptExSockAddrs, 
		sizeof(m_lpfnGetAcceptExSockAddrs),   
		&dwBytes, 
		NULL, 
		NULL))  
	{  
		this->_ShowMessage(_T("WSAIoctl δܻȡGuidGetAcceptExSockAddrsָ롣: %d\n"), WSAGetLastError());  
		this->_DeInitialize();
		return false; 
	}  


	// ΪAcceptEx ׼ȻͶAcceptEx I/O
	for( int i=0;i<MAX_POST_ACCEPT;i++ )
	{
		// ½һIO_CONTEXT
		PER_IO_CONTEXT* pAcceptIoContext = m_pListenContext->GetNewIoContext();

		if( false==this->_PostAccept( pAcceptIoContext ) )
		{
			m_pListenContext->RemoveContext(pAcceptIoContext);
			return false;
		}
	}

	this->_ShowMessage( _T("Ͷ %d AcceptEx"),MAX_POST_ACCEPT );

	return true;
}

////////////////////////////////////////////////////////////
//	ͷŵԴ
void CIOCPModel::_DeInitialize()
{
	// ɾͻбĻ
	DeleteCriticalSection(&m_csContextList);

	// رϵͳ˳¼
	RELEASE_HANDLE(m_hShutdownEvent);

	// ͷŹָ߳̾
	for( int i=0;i<m_nThreads;i++ )
	{
		RELEASE_HANDLE(m_phWorkerThreads[i]);
	}
	
	RELEASE(m_phWorkerThreads);

	// رIOCP
	RELEASE_HANDLE(m_hIOCompletionPort);

	// رռSocket
	RELEASE(m_pListenContext);

	this->_ShowMessage(_T("ͷԴ.\n"));
}


//====================================================================================
//
//				    Ͷɶ˿
//
//====================================================================================


//////////////////////////////////////////////////////////////////
// ͶAccept
bool CIOCPModel::_PostAccept( PER_IO_CONTEXT* pAcceptIoContext )
{
	ASSERT( INVALID_SOCKET!=m_pListenContext->m_Socket );

	// ׼
	DWORD dwBytes = 0;  
	pAcceptIoContext->m_OpType = ACCEPT_POSTED;  
	WSABUF *p_wbuf   = &pAcceptIoContext->m_wsaBuf;
	OVERLAPPED *p_ol = &pAcceptIoContext->m_Overlapped;
	
	// ΪԺĿͻ׼Socket( 봫ͳaccept ) 
	pAcceptIoContext->m_sockAccept  = WSASocket(AF_INET, SOCK_STREAM, IPPROTO_TCP, NULL, 0, WSA_FLAG_OVERLAPPED);  
	if( INVALID_SOCKET==pAcceptIoContext->m_sockAccept )  
	{  
		_ShowMessage(_T("AcceptSocketʧܣ: %d"), WSAGetLastError()); 
		return false;  
	} 

	// ͶAcceptEx
	if(FALSE == m_lpfnAcceptEx( m_pListenContext->m_Socket, pAcceptIoContext->m_sockAccept, p_wbuf->buf, p_wbuf->len - ((sizeof(SOCKADDR_IN)+16)*2),   
								sizeof(SOCKADDR_IN)+16, sizeof(SOCKADDR_IN)+16, &dwBytes, p_ol))  
	{  
		if(WSA_IO_PENDING != WSAGetLastError())  
		{  
			_ShowMessage(_T("Ͷ AcceptEx ʧܣ: %d"), WSAGetLastError());  
			return false;  
		}  
	} 

	return true;
}

////////////////////////////////////////////////////////////
// пͻʱ򣬽д
// е㸴ӣҪǿĻͿ׵ĵ....
// Ļɶ˿ڵĻһ

// ֮Ҫ֪ListenSocketContextҪһݳSocket
// ԭContextҪͶһAccept
//
bool CIOCPModel::_DoAccpet( PER_SOCKET_CONTEXT* pSocketContext, PER_IO_CONTEXT* pIoContext )
{
	SOCKADDR_IN* ClientAddr = NULL;
	SOCKADDR_IN* LocalAddr = NULL;  
	int remoteLen = sizeof(SOCKADDR_IN), localLen = sizeof(SOCKADDR_IN);  

	///////////////////////////////////////////////////////////////////////////
	// 1. ȡͻ˵ĵַϢ
	//  m_lpfnGetAcceptExSockAddrs ˰~~~~~~
	// ȡÿͻ˺ͱض˵ĵַϢ˳ȡͻ˷ĵһ
	this->m_lpfnGetAcceptExSockAddrs(pIoContext->m_wsaBuf.buf, pIoContext->m_wsaBuf.len - ((sizeof(SOCKADDR_IN)+16)*2),  
		sizeof(SOCKADDR_IN)+16, sizeof(SOCKADDR_IN)+16, (LPSOCKADDR*)&LocalAddr, &localLen, (LPSOCKADDR*)&ClientAddr, &remoteLen);  

	Global::g_time = time(NULL);
	Global::g_lastTime = COleDateTime::GetCurrentTime();
	this->_ShowMessage( _T("ͻ %s:%d ."), inet_ntoa(ClientAddr->sin_addr), ntohs(ClientAddr->sin_port) );
	//this->_ShowMessage( _T("ͻ %s:%d Ϣ%s."),inet_ntoa(ClientAddr->sin_addr), ntohs(ClientAddr->sin_port),pIoContext->m_wsaBuf.buf );
	if ( Global::g_bEnableLog )
	{
		// Jsonַ;
		Global::TLog tlog;
		cJSON *pJson = cJSON_Parse(Global::DeCode_URLUNICODE(pIoContext->m_wsaBuf.buf).c_str());
		if ( pJson )
		{
			tlog.report_type = cJSON_GetObjectItem(pJson, _T("ReportType")) ? cJSON_GetObjectItem(pJson, _T("ReportType"))->valuestring : "";
			tlog.report_data = cJSON_GetObjectItem(pJson, _T("prinMsg")) ? cJSON_GetObjectItem(pJson, _T("prinMsg"))->valuestring : "";
			if ( _tcscmp(tlog.report_type.c_str(), _T("printLog")) == 0 )
				Global::WritePythonLog(tlog.report_data.c_str());

			cJSON_Delete(pJson);
			pJson = NULL;
		}
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////
	// 2. Ҫע⣬ﴫListenSocketϵContextContextǻҪڼһ
	// һҪListenSocketϵContextƳһΪSocket½һSocketContext

	PER_SOCKET_CONTEXT* pNewSocketContext = new PER_SOCKET_CONTEXT;
	pNewSocketContext->m_Socket           = pIoContext->m_sockAccept;
	memcpy(&(pNewSocketContext->m_ClientAddr), ClientAddr, sizeof(SOCKADDR_IN));

	// ϣSocketɶ˿ڰ(Ҳһؼ)
	if( false==this->_AssociateWithIOCP( pNewSocketContext ) )
	{
		RELEASE( pNewSocketContext );
		return false;
	}  


	///////////////////////////////////////////////////////////////////////////////////////////////////
	// 3. µIoContextSocketͶݵһRecv
	PER_IO_CONTEXT* pNewIoContext = pNewSocketContext->GetNewIoContext();
	pNewIoContext->m_OpType       = RECV_POSTED;
	pNewIoContext->m_sockAccept   = pNewSocketContext->m_Socket;
	// BufferҪԼһݳ
	//memcpy( pNewIoContext->m_szBuffer,pIoContext->m_szBuffer,MAX_BUFFER_LEN );

	// ֮󣬾ͿԿʼSocketͶ
	if( false==this->_PostRecv( pNewIoContext) )
	{
		pNewSocketContext->RemoveContext( pNewIoContext );
		return false;
	}

	/////////////////////////////////////////////////////////////////////////////////////////////////
	// 4. ͶݳɹôͰЧĿͻϢ뵽ContextListȥ(ҪͳһͷԴ)
	this->_AddToContextList( pNewSocketContext );

	////////////////////////////////////////////////////////////////////////////////////////////////
	// 5. ʹ֮󣬰Listen SocketǸIoContextãȻ׼ͶµAcceptEx
	pIoContext->ResetBuffer();
	return this->_PostAccept( pIoContext ); 	
}

////////////////////////////////////////////////////////////////////
// Ͷݽ
bool CIOCPModel::_PostRecv( PER_IO_CONTEXT* pIoContext )
{
	// ʼ
	DWORD dwFlags = 0;
	DWORD dwBytes = 0;
	WSABUF *p_wbuf   = &pIoContext->m_wsaBuf;
	OVERLAPPED *p_ol = &pIoContext->m_Overlapped;

	pIoContext->ResetBuffer();
	pIoContext->m_OpType = RECV_POSTED;

	// ʼɺ󣬣ͶWSARecv
	int nBytesRecv = WSARecv( pIoContext->m_sockAccept, p_wbuf, 1, &dwBytes, &dwFlags, p_ol, NULL );

	// ֵ󣬲ҴĴ벢PendingĻǾ˵صʧ
	if ((SOCKET_ERROR == nBytesRecv) && (WSA_IO_PENDING != WSAGetLastError()))
	{
		this->_ShowMessage(_T("ͶݵһWSARecvʧܣ"));
		return false;
	}
	return true;
}

/////////////////////////////////////////////////////////////////
// нյݵʱ򣬽д
bool CIOCPModel::_DoRecv( PER_SOCKET_CONTEXT* pSocketContext, PER_IO_CONTEXT* pIoContext )
{
	Global::g_time = time(NULL);
	Global::g_lastTime = COleDateTime::GetCurrentTime();
	// Ȱһεʾ֣Ȼ״̬һRecv
	SOCKADDR_IN* ClientAddr = &pSocketContext->m_ClientAddr;
	//this->_ShowMessage( _T("յ  %s:%d Ϣ%s"),inet_ntoa(ClientAddr->sin_addr), ntohs(ClientAddr->sin_port), pIoContext->m_wsaBuf.buf );
	
	if ( Global::g_bEnableLog )
	{
		// Jsonַ;
		Global::TLog tlog;
		cJSON *pJson = cJSON_Parse(Global::DeCode_URLUNICODE(pIoContext->m_wsaBuf.buf).c_str());
		if ( pJson )
		{
			tlog.report_type = cJSON_GetObjectItem(pJson, _T("ReportType")) ? cJSON_GetObjectItem(pJson, _T("ReportType"))->valuestring : "";
			tlog.report_data = cJSON_GetObjectItem(pJson, _T("prinMsg")) ? cJSON_GetObjectItem(pJson, _T("prinMsg"))->valuestring : "";
			if ( _tcscmp(tlog.report_type.c_str(), _T("printLog")) == 0 )
				Global::WritePythonLog(tlog.report_data.c_str());

			cJSON_Delete(pJson);
			pJson = NULL;
		}
		
	}

	// ȻʼͶһWSARecv
	return _PostRecv( pIoContext );
}



/////////////////////////////////////////////////////
// (Socket)󶨵ɶ˿
bool CIOCPModel::_AssociateWithIOCP( PER_SOCKET_CONTEXT *pContext )
{
	// ںͿͻͨŵSOCKET󶨵ɶ˿
	HANDLE hTemp = CreateIoCompletionPort((HANDLE)pContext->m_Socket, m_hIOCompletionPort, (DWORD)pContext, 0);

	if (NULL == hTemp)
	{
		this->_ShowMessage(_T("ִCreateIoCompletionPort()ִ.룺%d"),GetLastError());
		return false;
	}

	return true;
}




//====================================================================================
//
//				    ContextList ز
//
//====================================================================================


//////////////////////////////////////////////////////////////
// ͻ˵Ϣ洢
void CIOCPModel::_AddToContextList( PER_SOCKET_CONTEXT *pHandleData )
{
	EnterCriticalSection(&m_csContextList);

	m_arrayClientContext.Add(pHandleData);	
	
	LeaveCriticalSection(&m_csContextList);
}

////////////////////////////////////////////////////////////////
//	ƳĳضContext
void CIOCPModel::_RemoveContext( PER_SOCKET_CONTEXT *pSocketContext )
{
	EnterCriticalSection(&m_csContextList);

	for( int i=0;i<m_arrayClientContext.GetCount();i++ )
	{
		if( pSocketContext==m_arrayClientContext.GetAt(i) )
		{
			RELEASE( pSocketContext );			
			m_arrayClientContext.RemoveAt(i);			
			break;
		}
	}

	LeaveCriticalSection(&m_csContextList);
}

////////////////////////////////////////////////////////////////
// տͻϢ
void CIOCPModel::_ClearContextList()
{
	EnterCriticalSection(&m_csContextList);

	for( int i=0;i<m_arrayClientContext.GetCount();i++ )
	{
		delete m_arrayClientContext.GetAt(i);
	}

	m_arrayClientContext.RemoveAll();

	LeaveCriticalSection(&m_csContextList);
}



//====================================================================================
//
//				       
//
//====================================================================================



////////////////////////////////////////////////////////////////////
// ñIPַ
CString CIOCPModel::GetLocalIP()
{
	// ñ
	char hostname[MAX_PATH] = {0};
	gethostname(hostname,MAX_PATH);                
	struct hostent FAR* lpHostEnt = gethostbyname(hostname);
	if(lpHostEnt == NULL)
	{
		return DEFAULT_IP;
	}

	// ȡIPַбеĵһΪصIP(Ϊһ̨ܻ󶨶IP)
	LPSTR lpAddr = lpHostEnt->h_addr_list[0];      

	// IPַתַʽ
	struct in_addr inAddr;
	memmove(&inAddr,lpAddr,4);
	m_strIP = CString( inet_ntoa(inAddr) );        

	return m_strIP;
}

///////////////////////////////////////////////////////////////////
// ñд
int CIOCPModel::_GetNoOfProcessors()
{
	SYSTEM_INFO si;

	GetSystemInfo(&si);

	return si.dwNumberOfProcessors;
}

/////////////////////////////////////////////////////////////////////
// ʾʾϢ
void CIOCPModel::_ShowMessage(const CString szFormat,...) const
{
	// ݴĲʽַ
	CString   strMessage;
	va_list   arglist;

	// 䳤
	va_start(arglist, szFormat);
	strMessage.FormatV(szFormat,arglist);
	va_end(arglist);

#if 0
	// ʾ
	CMainDlg* pMain = (CMainDlg*)m_pMain;
	if( m_pMain!=NULL )
	{
		pMain->AddInformation(strMessage);
		TRACE( strMessage+_T("\n") );
	}
#else
	Global::WriteTextLog(strMessage);
#endif
}

/////////////////////////////////////////////////////////////////////
// жϿͻSocketǷѾϿһЧSocketͶWSARecv쳣
// ʹõķǳsocketݣжsocketõķֵ
// Ϊͻ쳣Ͽ(ͻ˱߰εߵ)ʱ򣬷޷յͻ˶Ͽ֪ͨ

bool CIOCPModel::_IsSocketAlive(SOCKET s)
{
	int nByteSent=send(s,"",0,0);
	if (-1 == nByteSent) return false;
	return true;
}

///////////////////////////////////////////////////////////////////
// ʾɶ˿ϵĴ
bool CIOCPModel::HandleError( PER_SOCKET_CONTEXT *pContext,const DWORD& dwErr )
{
	// ǳʱˣټȰ  
	if(WAIT_TIMEOUT == dwErr)  
	{  	
		// ȷϿͻǷ񻹻...
		if( !_IsSocketAlive( pContext->m_Socket) )
		{
			this->_ShowMessage( _T("⵽ͻ쳣˳") );
			this->_RemoveContext( pContext );
			return true;
		}
		else
		{
			this->_ShowMessage( _T("ʱ...") );
			return true;
		}
	}  

	// ǿͻ쳣˳
	else if( ERROR_NETNAME_DELETED==dwErr )
	{
		this->_ShowMessage( _T("⵽ͻ쳣˳") );
		this->_RemoveContext( pContext );
		return true;
	}

	else
	{
		this->_ShowMessage( _T("ɶ˿ڲִ߳˳룺%d"),dwErr );
		return false;
	}
}




