/************** Begin of Log.h *******************************************/
/************************************************************************
 * Log.h
 *
 * edit by jesse in 2010-07-22
 * ־شͷļ
 ************************************************************************/
#if !defined(LOG_H_INCLUDED_)
#define LOG_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


///ûҪʹ־,ҪLOG_USELOG4CXXLOG4C_ENABLEͿ
#if !defined(LOG_USELOG4CXX) && !defined(LOG4C_ENABLE)

#define LOG4C(X) 
#define LOG4C_INIT()

#define LOG4C_PARAM_CFG_FILE_NAME(strCfgFileName) 
#define LOG4C_PARAM_LOG_LEVEL(strLogLevel) 
#define LOG4C_PARAM_LOG_FILE_NAME(strLogFileName) 
#define LOG4C_PARAM_LOG_FILE_SIZE(iFileSize) 
#define LOG4C_PARAM_LOG_FILE_NUM(iFileNum)
#define LOG4C_PARAM_REREAD_LOG_CFG_FILE(bReReadLogCfgFile)
#define LOG4C_INIT_WITH_PARAM()
#define LOG4C_INIT_WITH_PARAM_MULTI_PROCESS()

#define LOG4C_FINI()
#define LOG4C_INIT_DEFAULT()

#define LOG4C_NO_FILENUM(X) 
#define LOG4C_NO_FILENUM_NO_LAYOUT(X)
#define LOG4C_ORIGIN LOG4C_NO_FILENUM_NO_LAYOUT
#define LOG4C_BLOCK_BEGIN(X)
#define LOG4C_BLOCK_END(X) 
#define LOG4C_FUN(X) 
#define LOG4C_IF(X)
#define LOG4C_LINE()
#define LOG4C_HEX_DUMP(X)
#define LOG4C_RETURN(X)
#define LOG4C_RETURN_WITH_VALUE(X, reurnValue)

#else

#include <stdlib.h>

/**־¼ģʼ궨
ע: ʼ־ģȷ¼־
ʼҪӦóĿ¼־ļlog4crcԶһȱʡlog4crcļ
ʹ: LOG4C_INIT_DEFAULT();
:Jesse  :2010-07-22
*/
#define LOG4C_INIT_DEFAULT() \
	log_init_with_string("", "")

/**־¼ģʼ궨
ע: ʼ־ģȷ¼־
ʼҪӦóĿ¼־ļlog4crc
ʹ: LOG4C_INIT();
:Jesse  :2010-07-22
*/
#define LOG4C_INIT() \
	log_init()

/************************************************************************
Ϊͨò־ģĺ궨(ܺLOG4C_INITLOG4C_INIT_DEFAULT):
1.ȵLOG_PARAM_XXXXϵк궨ò,
1.1.־¼־ļȡ
1.2.LOG_PARAM_XXXXϵк궨ʹĬò
2.ȻLOG_INIT_WITH_PARAM궨ʼ־ģ顣
3.ʱͿԼ¼־ˡ
*/
#define LOG4C_PARAM_CFG_FILE_NAME(strCfgFileName) \
	log_set_log_cfg_file_name(strCfgFileName)

#define LOG4C_PARAM_LOG_LEVEL(strLogLevel) \
	log_set_log_level(strLogLevel)

#define LOG4C_PARAM_LOG_FILE_NAME(strLogFileName) \
	log_set_log_file_name(strLogFileName)

#define LOG4C_PARAM_LOG_FILE_SIZE(iFileSize) \
	log_set_log_file_size(iFileSize)

#define LOG4C_PARAM_LOG_FILE_NUM(iFileNum) \
	log_set_log_file_num(iFileNum)

#define LOG4C_PARAM_REREAD_LOG_CFG_FILE(bReReadLogCfgFile) \
	log_set_reread_log_cfg_file(bReReadLogCfgFile)

#define LOG4C_INIT_WITH_PARAM() \
	log_init_with_param()

#define LOG4C_INIT_WITH_PARAM_MULTI_PROCESS() \
	log_init_with_param_multi_process()

/************************************************************************/

/**־¼ģ궨
ע: ȷ־ģŲڴ桢Դй©
ʹ: LOG4C_FINI();
:Jesse  :2010-07-22
*/
#define LOG4C_FINI() \
	log_fini()

///LOG궨ȡĽ
typedef struct __LOG_PARAM
{
	char strMsg[LOG4C_BUFFER_SIZE_DEFAULT];
	int iPriority;

	///LOG4C_IFʱ
	int iCondition;

	///LOG4C_HEX_DUMPʱĲ
	char *strHexBuf;
	int iHexBufLen;
}LOG_PARAM;

#define LOG4C(X) \
{ \
	const LOG_PARAM log_param = log_vsprintf_wrapper X; \
	log_msg( __FILE__, __LINE__, DEFAULT_LOG_CATEGORY_NAME, log_param.iPriority, log_param.strMsg ); \
}

#define LOG4C_NO_FILENUM(X) \
{ \
	const LOG_PARAM log_param = log_vsprintf_wrapper X; \
	log_msg_no_file_num( DEFAULT_LOG_CATEGORY_NAME, log_param.iPriority, log_param.strMsg );  \
}

#define LOG4C_NO_FILENUM_NO_LAYOUT(X) \
{ \
	const LOG_PARAM log_param = log_vsprintf_wrapper X; \
	log_msg_no_file_num_no_layout( DEFAULT_LOG_CATEGORY_NAME, log_param.iPriority, log_param.strMsg ); \
}

#define LOG4C_ORIGIN LOG4C_NO_FILENUM_NO_LAYOUT

#define LOG4C_BLOCK_BEGIN(X) \
{ \
	const LOG_PARAM log_param = log_vsnprintf_wrapper_msg X; \
	log4c_block_begin(__FILE__, __LINE__, log_param.strMsg); \
}

#define LOG4C_BLOCK_END(X) \
{	\
	const LOG_PARAM log_param = log_vsnprintf_wrapper_msg X; \
	log4c_block_end(__FILE__, __LINE__, log_param.strMsg); \
}

#define LOG4C_FUN(X) \
{ \
	const LOG_PARAM log_param = log_vsnprintf_wrapper_msg X; \
	log_msg_func(__FILE__, __FUNCTION__, __LINE__, DEFAULT_LOG_CATEGORY_NAME, LOG4C_PRIORITY_TRACE, log_param.strMsg ); \
}

/** Output trace on condition.
This macro outputs a trace of any information needed, using standard stream
output operators. The output is only made if the conditional is TRUE. 
example: LOG4C_IF((4>3, LOG4C_PRIORITY_TRACE, "HELLO"));
*/
#define LOG4C_IF(X) \
{ \
	const LOG_PARAM log_param = log_condition_vsnprintf_wrapper X; \
	if( log_param.iCondition ) {\
		log_msg( \
			__FILE__, \
			__LINE__, \
			DEFAULT_LOG_CATEGORY_NAME, \
			log_param.iPriority, \
			log_param.strMsg\
		); 	\
	}\
}

/** Trace the execution of a line.
This macro outputs a trace of a source file line execution.
*/
#define LOG4C_LINE() \
{ \
	char strBuffer[128] = {0}; \
	snprintf(strBuffer, sizeof(strBuffer), "line:%d", __LINE__); \
	log_msg( \
		__FILE__, \
		__LINE__, \
		DEFAULT_LOG_CATEGORY_NAME, \
		LOG4C_PRIORITY_TRACE, \
		strBuffer \
		); \
}

/**ڴʮƷʽӡһ궨
example:LOG4C_HEX_DUMP((LOG4C_PRIORITY_TRACE, strHexBuf, iHexBufLen));
:Jesse :2010-07-22
*/
#define LOG4C_HEX_DUMP(X)	\
{	\
	log_hex_dump_vsnprintf_wrapper X; \
}

/** ļкŵ־,¼־ֱreturn
Ȼ뵽LOG궨
:Jesse :2010-07-22
*/ 
#define LOG4C_RETURN(X) \
{ \
	LOG4C(X); \
	return; \
}

/** ļкŵ־,¼־ֱreturn returnValue;
Ȼ뵽LOG궨
example:LOG4C_RETURN_WITH_VALUE(( LOG4C_PRIORITY_TRACE, "message%d", 1), returnValue);
:Jesse :2010-07-22
*/ 
#define LOG4C_RETURN_WITH_VALUE(X, returnValue) \
{ \
	LOG4C(X); \
	return returnValue; \
}

#endif ///!defined(LOG_USELOG4CXX) 	&& 	!defined(LOG4C_ENABLE)

#if ((defined(LOG_USELOG4CXX) && defined(__cplusplus)) || defined(LOG4C_ENABLE)) 

#ifdef _WIN32
///log4cȷʹñһЩ궨
#define snprintf _snprintf

#ifndef HAVE_CONFIG_H
	#define HAVE_CONFIG_H
#endif
///#define LOG4C_EXPORTS
#endif

///linuxʹõڵ
#ifdef linux
	///typedef int BOOL;
#ifndef BOOL 
	#define BOOL int
	#define FALSE 0
	#define TRUE 1
#endif
	#define sprintf_s snprintf
	///#define strcpy_s strncpy
#endif


/// ־ȱʡcategory
#ifndef DEFAULT_LOG_CATEGORY_NAME
	#define DEFAULT_LOG_CATEGORY_NAME "root"
#endif

/** ־¼
*/
/** fatal */	#define LOG_FATAL		LOG4C_PRIORITY_FATAL	
/** alert */	#define LOG_ALERT		LOG4C_PRIORITY_ALERT	
/** crit */	    #define LOG_CRIT		LOG4C_PRIORITY_CRIT		
/** error */	#define LOG_ERROR		LOG4C_PRIORITY_ERROR	
/** warn */	    #define LOG_WARN		LOG4C_PRIORITY_WARN		
/** notice */	#define LOG_NOTICE		LOG4C_PRIORITY_NOTICE	
/** info */	    #define LOG_INFO		LOG4C_PRIORITY_INFO		
/** debug */	#define LOG_DEBUG		LOG4C_PRIORITY_DEBUG	
/** trace */	#define LOG_TRACE		LOG4C_PRIORITY_TRACE	
/** notset */	#define LOG_NOTSET		LOG4C_PRIORITY_NOTSET	
/** unknown */	#define LOG_UNKNOWN		LOG4C_PRIORITY_UNKNOWN

#include <log4c/defs.h>

__LOG4C_BEGIN_DECLS

/** ־ģʼ
@return int:return 0 for success 
:Jesse  :2010-07-22
*/
LOG4C_API int log_init();

/** ־ģʼ,ָļ
@return int:return 0 for success 
:Jesse  :2010-07-22
*/
LOG4C_API int log_init_with_cfg_file(const char *strCfgFileName);

/** ־ģ
@return int:return 0 for success 
:Jesse  :2010-07-22
*/
LOG4C_API int log_fini();

/**ȡpriority
LOG_DEBUG(X)ĲӸú궨Ĳзpriorityֵ
@return const int : iPriority.
:Jesse  :2010-07-22
*/
LOG4C_API const int log_get_priority_wrapper(
	const int iPriority,	///־¼
	const char* strFormat,	///־ݸʽ
	...						///־
	);

/**
СΪcountĻݰֽ16ַӡ,
ֵΪָӦַ
÷ָĴ洢ҪñûʾĽɾ
*/
LOG4C_API void log4c_sprintf_data(char *buff, int count, char *dest_buffer);

/**־¼궨
ע: ʹʱʹLOG4C((X));
ʹ: LOG4C((LOG_ERROR, "Hello World! My Name is %s, and my age is %d ", "Jess", "28" ));
:Jesse  :2010-07-22
*/

LOG4C_API const LOG_PARAM  log_vsprintf_wrapper(
	const int iPriority,	///־¼
	const char* strFormat,	///־ݸʽ
	...						///־
	);

LOG4C_API const LOG_PARAM  log_condition_vsnprintf_wrapper(
	const int iCondition,	///
	const int iPriority,	///־¼
	const char* strFormat,	///־ݸʽ
	...						///־
	);

LOG4C_API void log_hex_dump_vsnprintf_wrapper(
	const int iPriority,	///־¼
	const char* strFormat,  ///־ݸʽ
	const char* strHexBuf,	///׵ַ
	const int iHexBufLen,	///
	...						///־
	);

LOG4C_API const LOG_PARAM log_vsnprintf_wrapper_msg(
	const char* strFormat,	///־ݸʽ
	...						///־
);

/** ־¼
־¼Ϊһַָָ
@return void
:Jesse  :2010-07-22
*/
LOG4C_API void log_msg(
			const char *strFile,	///ļ
			const int iLineNum,		///к
			const char *strCatName,	///category
			const int iPriority,	///־¼
			const char *strFormat,	///־ݸʽ
			...						///־
			);

LOG4C_API void log_msg_func(
	const char *strFile,	///ļ
	const char *strFuncName,///
	const int iLineNum,		///к
	const char *strCatName,	///category
	const int iPriority,	///־¼
	const char *strFormat,	///־ݸʽ
	...						///־
	);

/** ־¼,¼ļк
־¼Ϊһַָָ
@return void
:Jesse  :2010-07-22
*/
LOG4C_API void log_msg_no_file_num(
			const char *strCatName,	///category
			const int iPriority,	///־¼
			const char *strFormat,	///־ݸʽ
			...						///־
			);

/** ־¼,¼ļк,ûκlayoutתֱӦַı־
¼ûкţҲû̺߳ţҲûлس
־¼Ϊһַָָ
@return void
:Jesse  :2010-07-22
*/
LOG4C_API void log_msg_no_file_num_no_layout(
		   const char *strCatName,	///category
		   const int iPriority,		///־¼
		   const char *strFormat,		///־ݸʽ
		   ...						///־
		   );


/** ־ģʼ
־ļַݺ־ļΪ
Ӧļʹãոݺļ־ļʹ֮
@return int0 ɹ
:Jesse  :2010-07-22
*/
LOG4C_API int log_init_with_string(
			const char *strFileContent,
			const char *strFileName 
			);

/** ־ģʼ
־ļΪ
@return int0 ɹ
:Jesse  :2010-07-22
*/
LOG4C_API int log_init_with_cfg_file_wrapper(
			const char * strConfigFile
			);

/** ־ģʼ-־ļļ
־ļΪ
@return void
:Jesse  :2010-07-22
*/
LOG4C_API void log_set_log_cfg_file_name(const char *strFileName);

/** ־ģʼ-ɵ־ļļ
־ļΪ
@return void
:Jesse  :2010-07-22
*/
LOG4C_API void log_set_log_file_name(const char *strFileName);

/** ־ģʼ-־¼
@return void
:Jesse  :2010-07-22
*/
LOG4C_API void log_set_log_level(const char *strLogLevel);

/** ־ģʼ-־¼ļĴ
@return void
:Jesse  :2010-07-22
*/
LOG4C_API void log_set_log_file_size(const int iFileSize);

/** ־ģʼ-־¼ļĸ
¼󽫻عظǵһ־ļ
@return void
:Jesse  :2010-07-22
*/
LOG4C_API void log_set_log_file_num(const int iFileNum);

/** ־ģʼ-Ƿʵʱȡ־ļ
Ƿÿμ¼ʱȡ־ļ
@param:const BOOL m_bReReadLogCfgFile
@return void
:Jesse  :2010-07-22
*/
LOG4C_API void log_set_reread_log_cfg_file(const BOOL bReReadLogCfgFile);

/** ־ģʼ-־ģʼ
ĲΪļAPIõĲ
ԱһҪ־òú֮õĲЧ
@return int,OK,ɹ;FAILURE,ʧ
:Jesse  :2010-07-22
*/
LOG4C_API int log_init_with_param();

/** ־ģʼ-־ģʼ,Ķʵ־ͻ
ĲΪļAPIõĲ
ԱһҪ־òú֮õĲЧ
@return int,OK,ɹ;FAILURE,ʧ
:Jesse  :2010-07-22
*/
LOG4C_API int log_init_with_param_multi_process();

/** ־¼Blockʽıò
B-Entry־:
main.cpp(87) B-Entry	==> main
main.cpp(90) B-Entry	====> main_01
main.cpp(92) B-Entry	======> main_02
main.cpp(92) B-Exit	<====== main_02 
main.cpp(90) B-Exit	<==== main_01
@return void
:Jesse  :2010-07-22
*/
LOG4C_API void log4c_block_begin(const char * fileName, int lineNum, const char * traceName);

/** ־¼Blockʽıò
B-Exit־:
main.cpp(87) B-Entry	==> main
main.cpp(90) B-Entry	====> main_01
main.cpp(92) B-Entry	======> main_02
main.cpp(92) B-Exit	<====== main_02 
main.cpp(90) B-Exit	<==== main_01
@return void
:Jesse  :2010-07-22
*/
LOG4C_API void log4c_block_end(const char * fileName, int lineNum, const char * traceName);

/**ļǷ
@return const int : iPriority.
:Jesse  :2010-07-22
*/
extern const int log_check(void);

/**ļǷ,ֻ⴫ļ
@return const int : iPriority.
:Jesse  :2010-07-22
*/
extern const int log_check_with_cfg_file(const char *strCfgFileName);

/**ȡformat
LOG_DEBUG(X)ĲӸú궨Ĳзformatֵ
@return const char* : strFormat
:Jesse  :2010-07-22
*/
extern const char* log_get_format_wrapper(
	const int iPriority,	///־¼
	const char* strFormat,	///־ݸʽ
	...						///־
	);


/** appender
@return int:
:Jesse  :2010-07-22
*/
extern int log_setappender(
			const char *strCatName,		///category
			const char *strAppenderName ///appender
			);

/** ־¼
֧printfĴʽ
@return void
:Jesse  :2010-07-22
*/
extern void log_log(
			const char *strCatName,	///category
			const int iPriority,	///־¼
			const char *strFormat,	///־ݸʽ
			...						///־
			);

/** ־ģʼ-־ģʹʵ
@return void
:Jesse  :2010-07-22
*/
extern void IncreaseLogModuleUsage();

__LOG4C_END_DECLS

///#include "log4c.h"
#endif ///((defined(LOG_USELOG4CXX) && defined(__cplusplus)) || defined(LOG4C_ENABLE))

#endif // !defined(LOG_H_INCLUDED_)
/************** End of Log.h *******************************************/