/************** Begin of vos.h *******************************************/
/**********************************************************
* Ȩ (C)2002, ͨѶɷ޹˾
*
* ļƣ vos.h
* ļʶ
* ժҪ ϵͳװͷļҪͷļݽṹӿڵȣ
* ˵ 
* ǰ汾 V1.0
*     ߣ 
* ڣ 2003/08/10
*
* ޸ļ¼1
*    ޸ڣ
*      ţ
*      ˣ
*    ޸ݣ
**********************************************************/
#ifndef _VOS_H_
#define _VOS_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "voscfg.h"
	/**********************************************************
	*                          궨                         *
	**********************************************************/

#define    VOS_NULL                      0x0

#define    VOS_TRUE                      1
#define    VOS_FALSE                     0

#define    VOS_SUCCESS                   0     /* PSOSֵ                    */
#define    VOS_PCBINDEXNO                0     /* pcbindexıĴ    */
#define    VOS_TASKPRINO                 1     /* ȼıĴ  */
#define    VOS_TICKNUM                   1     /* жϵtick                  */
#define    TIMER_SCAN_EVENT              (WORD32)(1<<15)
#define    MEMLEAK_SCAN_EVENT            (WORD32)(1<<16)
#define    MAX_LENGTH_BUF                512

#define    VOS_NO_WAIT                   0x0
#define    VOS_WAIT_FOREVER              -1

#define    VOS_SEM_DELETE_SAFE           0x04
#define    VOS_SEM_INVERSION_SAFE        0x08

#define    VOS_VM_STATE_MASK_VALID       0x03
#define    VOS_VM_STATE_MASK_WRITABLE    0x0c
#define    VOS_VM_STATE_MASK_CACHEABLE   0x30
#define    VOS_VM_STATE_MASK_WBACK       0x40
#define    VOS_VM_STATE_MASK_GLOBAL      0x80
#define    VOS_VM_STATE_MASK_GUARDED     0x80

#define    VOS_VM_STATE_VALID            0x01
#define    VOS_VM_STATE_VALID_NOT        0x00
#define    VOS_VM_STATE_WRITABLE         0x04
#define    VOS_VM_STATE_WRITABLE_NOT     0x00
#define    VOS_VM_STATE_CACHEABLE        0x10
#define    VOS_VM_STATE_CACHEABLE_NOT    0x00
#define    VOS_VM_STATE_WBACK			 0x40
#define    VOS_VM_STATE_WBACK_NOT		 0x00
#define    VOS_VM_STATE_GLOBAL			 0x80
#define    VOS_VM_STATE_GLOBAL_NOT		 0x00
#define    VOS_VM_STATE_GUARDED			 0x80
#define    VOS_VM_STATE_GUARDED_NOT		 0x00

#define    MAXCOUNTSEM                   10000
#define    VOS_MAX_PATH_LEN              50
#define    VOS_MAX_FILENAME_LEN          60
#define    VOS_MAX_EXP_FILENAME_LEN      8

#if OS_TYPE == OS_VXWORKS
#define    NULL_TASKID               ERROR
#define    NULL_SEMID                NULL
#define    NULL_MSGQID               NULL
#define    NULL_MSGGET               0
#define    DIR_CODE                  0x2f    /*  "/" */
#define    DIR_CONCATE_CODE            "/"
#endif

#if OS_TYPE == OS_WINNT
#define    NULL_TASKID               NULL
#define    NULL_SEMID                NULL
#define    NULL_MSGQID               NULL
#define    NULL_MSGGET               0
#define    DIR_CODE                  0x5c    /* " \" */
#define    DIR_CONCATE_CODE            "\\"
#define    RDONLY                    0
#define    WRONLY                    1
#define    RDWR                      2
#define    WINNT_ERROR               -1    
#endif

#if OS_TYPE == OS_PSOS
#define    NULL_TASKID               0xffffffff
#define    NULL_SEMID                0xffffffff
#define    NULL_MSGQID               0xffffffff
#define    NULL_MSGGET               0xffffffff
#define    MSG_Q_FIFO                0x00
#define    MSG_Q_PRIORITY            0x01
#define    MSG_PRI_NORMAL            0x00
#define    MSG_PRI_URGENT            0x01
#define    RAM_BLOCKS                2*360  /* RAM diskС */
#define    RAM_PATH_LENGTH           80
#define    MIN_EXPAN_BLOCKS          10
#endif

#if OS_TYPE == OS_LINUX
#ifdef VXWORKS_TO_LINUX
#define    NULL_TASKID               ERROR
#define    NULL_SEMID                NULL
#define    NULL_MSGQID               NULL
#else
#define    NULL_TASKID               0xffffffff
#define    NULL_SEMID                0xffffffff
#define    NULL_MSGQID               0xffffffff
#endif
#define    NULL_MSGGET               0
#define    DIR_CODE                  0x2f  /*  "/" */

#endif

#if OS_TYPE == OS_KLINUX
#define    NULL_TASKID               ERROR
#define    NULL_SEMID                 NULL
#define    NULL_MSGQID              NULL
#define    TRUE   1
#define    FALSE 0
#define    DIR_CONCATE_CODE        "/"
#define    DIR_CODE                0x2f
#define    VOS_ISDIR(mode)    ((mode & S_IFMT) == S_IFDIR)    /* жǷĿ¼ */
	// #define    malloc(size) __vmalloc(size,GFP_KERNEL |__GFP_HIGHMEM, PAGE_KERNEL)
	//#define    free(buf)      vfree(buf)
#define    printf  printk
#endif


	/************** SOCKET & TCP ***************/
#define NELEMENTS(array)  (sizeof (array) / sizeof ((array) [0]))

#ifndef HASMAX
#ifndef max
#define max(a,b) ((a)>(b)?(a):(b))
#endif
#endif

#ifndef HASMIN
#ifndef min
#define min(a,b) ((a)<(b)?(a):(b))
#endif
#endif 


#if (OS_TYPE == OS_VXWORKS)
#define SOCKET_ERROR     ERROR
#define SOMAXCONN        5
#define VOS_EWOULDBLOCK  EWOULDBLOCK
#define VOS_ECONNRESET   ECONNRESET
#endif

#if (OS_TYPE == OS_WINNT)
	/* Ԫظ */
	///(pclintע͵)#define NELEMENTS(array)  (sizeof (array) / sizeof ((array) [0]))
#define CloseSocket closesocket
#define bcopy(src,dst,size) memcpy(dst,src,size)
#define errnoGet         WSAGetLastError
	typedef long int STATUS ;
#define VOS_EWOULDBLOCK WSAEWOULDBLOCK
#define VOS_ECONNRESET WSAECONNRESET
#endif


#if ((OS_TYPE == OS_LINUX) ||(OS_TYPE == OS_KLINUX))
	typedef unsigned long ULONG;
#define errnoGet() errno
#define SOCKET_ERROR     ERROR
#define SOMAXCONN	128
#define VOS_EWOULDBLOCK  EWOULDBLOCK
#define VOS_ECONNRESET ECONNRESET

#endif

#if ((OS_TYPE == OS_VXWORKS) || (OS_TYPE == OS_LINUX)||(OS_TYPE == OS_KLINUX))
	typedef int SOCKET;
#endif

	/**************** VOS TIMER *******************/

	/* ʱжϾ10ms */
#define  TIMER_RESOLUTION    10 


#if (OS_TYPE == OS_WINNT)
#ifndef WIN32_LEAN_AND_MEAN
#define WIN32_LEAN_AND_MEAN
#endif
#include <windows.h>
#include <mmsystem.h>
#define  VOS_TIMERCALLBACK     LPTIMECALLBACK  
#define  VOS_TIMER_ID          WORD32 
#define  INVALID_VOS_TIMERID   0
#endif

#if (OS_TYPE == OS_VXWORKS)
#define  VOS_TIMERCALLBACK     FUNCPTR  
#define  VOS_TIMER_ID          WDOG_ID 
#define  INVALID_VOS_TIMERID   NULL

#define  TIMER_ONESHOT         0
#define  TIMER_PERIODIC        1
#endif

#if (OS_TYPE == OS_PSOS)
#define  VOS_TIMERCALLBACK     LPVOID  
#define  VOS_TIMER_ID          WORD32 
#define  INVALID_VOS_TIMERID   0xffffffff
#endif

#if (OS_TYPE == OS_LINUX)
	typedef  void(*VOS_TIMERCALLBACK)(int);
#define  VOS_TIMER_ID          WORD32 
#define  INVALID_VOS_TIMERID   0
#endif

#if (OS_TYPE == OS_KLINUX)
#ifndef HZ
#define HZ 100
#endif     
	extern unsigned long volatile jiffies;

	typedef  void(*VOS_TIMERCALLBACK)(WORD32);
	typedef  struct timer_list    *VOS_TIMER_ID;
#define  INVALID_VOS_TIMERID   NULL    
#endif

	/**************** VOS VOLUME *******************/
#define        VOLNAME_LENGTH            10


	/**********************************************************
	*                          Ͷ                       *
	**********************************************************/

#if    OS_TYPE == OS_VXWORKS
#define    VOS_ISDIR(mode)    ((mode & S_IFMT) == S_IFDIR)    /* жǷĿ¼ */
#define    VOS_ISCHR(mode)    ((mode & S_IFMT) == S_IFCHR)    /* Ƿ ַ */
#define    VOS_ISBLK(mode)    ((mode & S_IFMT) == S_IFBLK)    /* жǷ */
#define    VOS_ISREG(mode)    ((mode & S_IFMT) == S_IFREG)    /* жǷ */
#define    VOS_ISFIFO(mode)   ((mode & S_IFMT) == S_IFIFO)    /* жǷfifo  */
#elif OS_TYPE== OS_WINNT
#define    VOS_ISDIR(mode)    ((mode & _S_IFMT) == _S_IFDIR)    /* жǷĿ¼ */
#define    VOS_ISCHR(mode)    ((mode & _S_IFMT) == _S_IFCHR)    /* Ƿ ַ */
#define    VOS_ISBLK(mode)    ((mode & _S_IFMT) == _S_IFBLK)    /* жǷ */
#define    VOS_ISREG(mode)    ((mode & _S_IFMT) == _S_IFREG)      /* жǷ */
#define    VOS_ISFIFO(mode)   ((mode & _S_IFMT) == _S_IFIFO)    /* жǷfifo  */
#endif


	/* IDͶ */
#if OS_TYPE == OS_VXWORKS
	typedef SWORD32  TASK_ID;
	typedef PART_ID  MEMPART_ID;
	typedef FUNCPTR  VOS_FUNCPTR;
	typedef WIND_TCB TASK_TCB;	
#endif

#if OS_TYPE == OS_PSOS
	typedef WORD32  TASK_ID;
	typedef VOS_VOIDFUNCPTR  VOS_FUNCPTR;
	typedef WORD32  SEM_ID;
	typedef WORD32  MSG_Q_ID;
	typedef WORD32  MEMPART_ID;	
#endif

#if OS_TYPE == OS_WINNT
	typedef HANDLE   TASK_ID;
	typedef HANDLE   SEM_ID;
	typedef HANDLE   MEMPART_ID;
	typedef HANDLE   MSG_Q_ID;
	typedef LPTHREAD_START_ROUTINE VOS_FUNCPTR;	
#endif

#if OS_TYPE == OS_LINUX
	typedef void        VOID;
	typedef pthread_t	TASK_ID;
	typedef sem_t *		SEM_ID; 
#ifndef PART_ID
#define PART_ID int
#endif /*wenhm,050826*/
	typedef PART_ID     MEMPART_ID;
	typedef void*       VOS_FUNCPTR; 
	///typedef void (*AutoRunHandler)(void);
	typedef WORD32      MSG_RECEIVE;/*yangyp*/    
	typedef WORD32      MSG_Q_ID;

	///typedef FUNCPTR     VOS_FUNCPTR; 
	///typedef WIND_TCB    TASK_TCB;
	///typedef WORD16      VOS_TIMER_ID;/*yangyp*/
	///typedef WORD32		SEM_ID;
	///typedef SWORD32     TASK_ID;
#endif
#if OS_TYPE == OS_KLINUX
	typedef void        VOID;
	typedef pthread_t	TASK_ID;
	typedef sem_t*		SEM_ID; 
	/*typedef PART_ID     MEMPART_ID;
	typedef FUNCPTR     VOS_FUNCPTR;
	typedef WIND_TCB    TASK_TCB;*/
	typedef WORD32      MEMPART_ID;
	typedef void*       VOS_FUNCPTR;
	typedef WORD32      MSG_RECEIVE;/*yangyp*/
	typedef WORD16      VOS_TIMER_ID;/*yangyp*/
	typedef WORD32      MSG_Q_ID;
#endif


	/* VOS_STATUS: VOS㺯ֵ */
	typedef enum
	{
		VOS_ERROR = -1,
		VOS_OK = 0,
	}VOS_STATUS;

	/* VOS_SEM_STATE  źʼ״̬ */
	typedef enum
	{
		VOS_SEM_EMPTY,
		VOS_SEM_FULL
	}VOS_SEM_STATE;

	/* ź:Ƚȳȼ */
	typedef enum
	{
		VOS_SEM_Q_FIFO,
		VOS_SEM_Q_PRIORITY
	}VOS_SEM_QUEUE_TYPE;

	/* Ϣȼ */
	typedef enum
	{
		VOS_MSG_PRI_NORMAL,
		VOS_MSG_PRI_URGENT
	}VOS_MSG_TYPE;

	/* ϢŶ:Ƚȳȼ */
	typedef enum
	{
		VOS_MSG_Q_FIFO,
		VOS_MSG_Q_PRIORITY
	}VOS_MSGQUE_TYPE;

	/* ״̬ */
	typedef enum
	{
		VOS_TASK_STATUS_NULL,
		VOS_TASK_STATUS_RUNNING,
		VOS_TASK_STATUS_READY,
		VOS_TASK_STATUS_PEND,
		VOS_TASK_STATUS_SUSPEND,
		VOS_TASK_STATUS_DEBUG,
		VOS_TASK_STATUS_DEAD
	}VOS_TASK_STATUS;

	/* ͷֵΪVOIDĺ */
	typedef   VOID(*VOS_VOIDFUNCPTR)(VOID);

	/**********************************************************
	*                          ݽṹ                   *
	**********************************************************/

	/* ϵͳʱ */
	typedef struct tagSYS_CLOCK
	{
		WORD16             wSysYear;
		WORD16             wSysMon;
		WORD16             wSysDay;
		WORD16             wSysHour;
		WORD16             wSysMin;
		WORD16             wSysSec;
		WORD16             wSysWeek;
		WORD16             wMilliSec;
	}T_SYS_CLOCK;

#undef st_atime
#undef st_mtime
#undef st_ctime
	/* ļ״̬ */
	typedef struct tagFileStat
	{
		WORD32  st_dev;
		WORD32  st_ino;
		WORD16  st_mode;
		SWORD16 st_nlink;
		SWORD16 st_uid;
		SWORD16 st_gid;
		WORD32  st_rdev;
		SWORD32 st_size;
		SWORD32 st_atime;
		SWORD32 st_mtime;
		SWORD32 st_ctime;
	}T_FileStat;


	/* added by »,ļķ*/
	enum Permissions {
		/// File has world execute permission
		WorldExecute = 1,   
		/// File has world write permission
		WorldWrite = 2,     
		/// File has world read permission
		WorldRead = 4,      
		/// File has group execute permission
		GroupExecute = 8,   
		/// File has group write permission
		GroupWrite = 16,    
		/// File has group read permission
		GroupRead = 32,     
		/// File has owner execute permission
		UserExecute = 64,   
		/// File has owner write permission
		UserWrite = 128,    
		/// File has owner read permission
		UserRead = 256,     
		/// All possible permissions.
		AllPermissions = 0x1ff,   
		/// Owner read & write plus group and world read permissions.
		DefaultPerms = UserRead|UserWrite|GroupRead|WorldRead,
		/// Owner read & write & execute plus group and world read & exectute permissions.
		DefaultDirPerms = DefaultPerms|UserExecute|GroupExecute|WorldExecute		
	};

#if OS_TYPE == OS_WINNT
	/**
	ṹMINIAceһʹʱ,
	os_dirent.hӦĽṹĳͻ,os_dirent.hṹвACE_LACKS_STRUCT_DIRŻЧ,
	˿趨vos.hвACE_LACKS_STRUCT_DIR궨ʱĽṹdirentЧ. 
	added by wenhm in 2007.05.16
	*/
#ifndef ACE_LACKS_STRUCT_DIR
	/* · */
	struct  dirent
	{
		unsigned short d_ino;
		unsigned short d_off;
		unsigned short d_reclen;
		CHAR     d_name [VOS_MAX_FILENAME_LEN + 1];
	};
#endif


	/* Ŀ¼Ķ */
	typedef struct
	{
		SWORD32       dd_fd;        /* Ŀ¼ļ */
		SWORD32       dd_cookie;    /* Ŀ¼еļضʾfilesys-specific marker within dir */
		struct dirent dd_dirent;    /* · */
	}DIR;


#endif



	/**********************************************************
	*                          ԭ                       *
	**********************************************************/

	/******************  ģ ************************/
	TASK_ID       VOS_CreateTask(CHAR *pTaskName, SWORD32 priority,
		SWORD32 options, SWORD32 stackSize,
		VOS_FUNCPTR pTaskEntry, SWORD32 arg1,
		SWORD32 arg2, SWORD32 arg3, SWORD32 arg4,
		SWORD32 arg5, SWORD32 arg6, SWORD32 arg7,
		SWORD32 arg8, SWORD32 arg9, SWORD32 arg10);

	VOS_STATUS    VOS_DeleteTask(TASK_ID taskId);
	VOS_STATUS    VOS_SuspendTask(TASK_ID taskId);
	VOS_STATUS    VOS_ResumeTask(TASK_ID  taskId);
	VOS_STATUS    VOS_SetPriority(TASK_ID TaskId, SWORD32 newPriority);
	SWORD32       VOS_GetPriority(TASK_ID TaskId);

	VOS_STATUS    VOS_DelayTask(SWORD32 delayTime);
	TASK_ID       VOS_GetSelfTaskID(VOID);
	VOS_STATUS    VOS_SuspendSelf(VOID);

	VOS_TASK_STATUS VOS_GetTaskStatus(TASK_ID taskId);
	VOID          VOS_CheckStack(TASK_ID taskId);


	/************** źź *****************/
	SEM_ID        VOS_CreateBSem(SWORD32 options, VOS_SEM_STATE initialState);
	SEM_ID        VOS_CreateCSem(SWORD32 options, SWORD32 initialState);
	SEM_ID        VOS_CreateMSem(SWORD32 options);
	VOS_STATUS    VOS_DeleteSem(SEM_ID semId);
	VOS_STATUS    VOS_TakeSem(SEM_ID semId, SWORD32 timeout);
	VOS_STATUS    VOS_GiveSem(SEM_ID semId);


	/**************** ڴģ ***************************/
	MEMPART_ID    VOS_CreateMemPart(CHAR *pPool, WORD32 poolSize);
	VOID         *VOS_AllocMemPart(MEMPART_ID memPartId, WORD32 size);
	VOS_STATUS    VOS_FreeMemPart(MEMPART_ID memPartId, CHAR *pBlock);

	CHAR         *VOS_GetPhysMemTop(VOID);
	WORD32        VOS_GetRnFreeInfo(WORD32 dwRnId);

	/********************* жϴ ******* ******************/
	SWORD32       VOS_LockInt();
	VOID          VOS_UnlockInt(SWORD32 dwLevel);


	/********************* Ϣ **************************/
	MSG_Q_ID      VOS_CreateMsgQue(WORD32 dwMaxMsgNum,
		WORD32 dwMaxMsgLength,
		BYTE ucOptions);
	VOS_STATUS    VOS_DeleteMsgQue(MSG_Q_ID wMsgId);
	VOS_STATUS    VOS_SendMsg(MSG_Q_ID wMsgId,
		CHAR *pcMsgData,
		WORD32 dwlen,
		SWORD32 dwtimeout,
		BYTE ucPrior);
	WORD32        VOS_ReceiveMsg(MSG_Q_ID wMsgId,
		CHAR  *pcMsgDataBuffer,
		WORD32 dwlen,
		SWORD32 iTimeout);
	WORD32        VOS_GetCurMsgs(MSG_Q_ID wMsgId);


	/********************* ʱģ **************************/
	VOS_STATUS    VOS_ConnectClk(VOS_VOIDFUNCPTR clkIntEntry);
	SWORD32       VOS_GetSysClkRate(VOID);
	WORD32        VOS_GetTick();
	VOS_STATUS    VOS_IniSysClk(T_SYS_CLOCK *pSysSoftClk);
	VOS_STATUS    VOS_SetSysClkRate(SWORD32 sdTicPerSend);

	VOS_STATUS    VOS_TimeSet(T_SYS_CLOCK *pSysSoftClk);
	VOS_STATUS    VOS_TimeGet(T_SYS_CLOCK *pSysSoftClk);

	VOS_TIMER_ID VOS_RelTimer(
		WORD32 dwTimeLength, 
		VOS_TIMERCALLBACK lpTimeProc,
		WORD32 dwUser,
		WORD32 dwEvents			 
		);

	VOS_TIMER_ID VOS_AbsTimer(
		T_SYS_CLOCK tRelTimerSet, 
		VOS_TIMERCALLBACK lpTimeProc,
		WORD32 dwUser,
		WORD32 dwEvents			 
		);

	VOS_TIMER_ID VOS_PerTimer(
		WORD32 dwTimeLength, 			 
		VOS_TIMERCALLBACK lpTimeProc,
		WORD32 dwUser,
		WORD32 dwEvents			 
		);

	VOS_STATUS   VOS_TimerKill(VOS_TIMER_ID TimerId);


	/********************* 쳣 **************************/
	SWORD32       VOS_GetErrno(VOID);
	VOID          VOS_AddExcHook(VOS_FUNCPTR excHookEntry);

	/********************* ʼVOS *************************/
	VOS_STATUS    VOS_InitVOS(VOID);


	/****************** ǰPCB **********************/
	VOS_STATUS    VOS_SetCurPCBIndex(WORD16  wIndex);
	WORD16        VOS_GetCurPCBIndex(VOID);
	VOS_STATUS    VOS_FreeTlsData(VOID);

	/******************      ¼ģ   **********************/
	VOS_STATUS    VOS_SendEvent(TASK_ID taskId, WORD32 dwEvents);
	VOS_STATUS    VOS_ReceiveEvent(WORD32 dwEvents, WORD32 dwTimeout,
		WORD32 *ptEventsR);


	/******************  Դӡ  **********************/
	VOID          VOS_Display(const CHAR *fmt, ... );


	/********************ļϵͳģ**********************/
	SWORD32       VOS_Create(CHAR *pcFileName);
	VOS_STATUS    VOS_Delete(CHAR *pcFileName);
	SWORD32       VOS_Open(CHAR *pcFileName,SWORD32 sdwFlag,SWORD32 sdwMode);
	VOS_STATUS    VOS_Close(SWORD32 sdwFileHandle);
	VOS_STATUS    VOS_Rename(CHAR *pcOldFileName,CHAR *pcNewFileName);
	SWORD32       VOS_Read(SWORD32 sdFileHandle,VOID *pBuffer,SWORD32 sdCount);
	SWORD32       VOS_Write(SWORD32 sdFileHandle,VOID *pBuffer,SWORD32 sdCount);
	SWORD32       VOS_FileLength(CHAR *pcFileName);
	SWORD32       VOS_Lseek(SWORD32 sdFileHandle,SWORD32 sdOffset,SWORD32 sdOrigin);
	VOS_STATUS    VOS_CreateDir(CHAR *pcDirName);
	VOS_STATUS    VOS_DeleteDir(CHAR *pcDirName);
	VOS_STATUS    VOS_RenameDir(CHAR *pcOldDirName,CHAR *pcNewDirName);
	DIR           *VOS_OpenDir(CHAR *pcDirName);
	struct dirent *VOS_ReadDir(DIR *pDir);
	VOS_STATUS    VOS_CloseDir(DIR *pDir);
	VOS_STATUS    VOS_Stat(CHAR *pcFileName, T_FileStat *pStat);
	VOS_STATUS    VOS_CreateMemDev(CHAR      *pcRamDiskName,
		CHAR      *pcRamAddr,
		SWORD32   sdwCHARsPerBlk,
		SWORD32   sdwBlksPerTrack,
		SWORD32   sdwNBlocks,
		SWORD32   sdwBlkOffset);
	VOS_STATUS    VOS_StartFtpServer(LPVOID   pLoginRtn,
		SWORD32  sdwStackSize);

	VOS_STATUS    VOS_StopFtpServer(VOID);

#if OS_TYPE == OS_PSOS
	VOS_STATUS    VOS_FileSystemInit(VOID);
#endif

	/****************** SOCKET **********************/
	VOS_STATUS  VOS_InitSocketLib(VOID);
	SOCKET      VOS_Socket(SWORD32 family, SWORD32 type,SWORD32 protocol );
	VOS_STATUS  VOS_Bind(SWORD32 s, const struct sockaddr * name,  SWORD32 namelen);
	VOS_STATUS  VOS_Accept(SOCKET s ,struct sockaddr * addr,SWORD32* addrlen );
	VOS_STATUS  VOS_Listen(SOCKET s ,SWORD32 backlog );
	SWORD32     VOS_Send(SOCKET s,const char * buffer,SWORD32 len, SWORD32 flags);
	SWORD32     VOS_Recv(SOCKET s,const char * buffer,SWORD32 len,SWORD32 flags);
	VOS_STATUS  VOS_CloseSocket(SOCKET s);
	VOS_STATUS  VOS_CleanUp(void);
	VOS_STATUS  VOS_ConnectWithTimeout(SOCKET s,  struct sockaddr * adrs,  int adrsLen,
	struct timeval *  timeVal );
	SWORD32     VOS_SendTo(SOCKET s,const char *buffer,SWORD32 len, SWORD32 flags,
	struct sockaddr *to, int tolen );
	SWORD32     VOS_SendSocketMsg(SOCKET s,  struct msghdr  *mp, SWORD32 flags);
	SWORD32     VOS_RecvFrom(SOCKET s,const char *buffer,SWORD32 len, SWORD32 flags,
	struct sockaddr *from, int  * pFromLen);
	SWORD32     VOS_RecvSocketMsg(SOCKET s,  struct msghdr  *mp, SWORD32 flags);
	VOS_STATUS  VOS_Shutdown(SOCKET s, int how);
	VOS_STATUS  VOS_SetSockOpt (SOCKET s,  int level,  int  optname, char * optval, int optlen );
	VOS_STATUS  VOS_GetSockOpt (SOCKET s,  int level,  int  optname, char * optval, int *optlen );
	VOS_STATUS  VOS_GetSockName(SOCKET s,   struct sockaddr * name,   int * namelen);
	VOS_STATUS  VOS_GetPeerName (SOCKET s, struct sockaddr * name, int * namelen);
	SWORD32     VOS_Select(int width, fd_set  *pReadFds, fd_set  * pWriteFds,
		fd_set * pExceptFds, struct timeval * pTimeOut);
	SWORD32     VOS_Ioctl(int fd, int function,int arg);

	/****************** Exec **********************/
	VOS_STATUS VOS_Exec(
		const CHAR * strFile,		///Ҫִеĳ
		const CHAR * strArgs		///Ҫв
		);

	VOS_STATUS VOS_ExecByFork(
		const CHAR * strFile,	///Ҫִеĳ
		const CHAR * strArgs	///Ҫв
		);

	VOS_STATUS VOS_ForceDelete(CHAR *pcFileName);

	SWORD32 VOS_Chmod(
		const CHAR * pcFileName, ///ļ
		int iPermissions         ///Ҫõļ
		);

	VOS_STATUS VOS_SetRLimit(const int iCoreFileSize);

	VOS_STATUS VOS_GetTimeOfDay(struct timeval *tv, struct timezone *tz);

#ifdef __cplusplus
}
#endif


#endif
/************** End of vos.h *******************************************/