﻿// pch.h: 这是预编译标头文件。
// 下方列出的文件仅编译一次，提高了将来生成的生成性能。
// 这还将影响 IntelliSense 性能，包括代码完成和许多代码浏览功能。
// 但是，如果此处列出的文件中的任何一个在生成之间有更新，它们全部都将被重新编译。
// 请勿在此处添加要频繁更新的文件，这将使得性能优势无效。

#ifndef PCH_H
#define PCH_H

// 添加要在此处预编译的标头
#include "framework.h"

#include <string>
#include <vector>
#include <thread>
#include <Dbt.h>	// 设备头文件;
#include <queue>
#include <map>
#include "Global.h"

using namespace std;

#include <imm.h>
#pragma comment(lib,"Imm32.lib")

#include "OTA.h"
#include <afxcontrolbars.h>
#include "db.h"

extern COTA g_ota;
extern CSIACP g_siacp;
extern MIDInfo g_midInfo;
extern CDataImpl g_db;

// 某机芯要求处理;
#define DEL_CLIENT_TYPE_ERROR_LOG 1		// 去除Client type读取失败后，打印红色的出错日志;改为正常颜色日志输出，防止厂线员工有疑问;
#define ENABLE_CHASSIS_CONFIG 0
#define ENABLE_VCODE 0
#define SAVE_AUTO_ONLINE 1
#endif //PCH_H
