// UB530SDK.cpp :  DLL Ӧóĵ
//

#include "stdafx.h"
#include "Python.h"
#include "MemoryServer.h"

CMemoryServer g_ub530;
PyObject *g_list = NULL;
/************************************************************************/
/*  [7/4/2018 Wang];
/*  Ƿ;
/*  ;
/*  	[IN] ִļ·;
/*  	[OUT] ;
/*  	[IN/OUT] ;
/*  أɹؽID!= 0;
/*  ע⣺;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
static PyObject* IsAppRunning(PyObject *self, PyObject *args)
{
	// Ӧó·;
	const char* pszExePath = NULL;
	if (!PyArg_ParseTuple(args, "s", &pszExePath))
		return NULL;

	return Py_BuildValue("i", IsAppRunning(pszExePath));
}

/************************************************************************/
/*  [7/2/2018 Wang];
/*  ;
/*  ;
/*  	[IN] ִļ·,Ĭϴ豸ֵΪ0豸;
/*  	[OUT] ;
/*  	[IN/OUT] ;
/*  أɹ1ʧܷ0;
/*  ע⣺;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
static PyObject* StartApp(PyObject *self, PyObject *args)
{
	// Ӧó·;
	const char* pszExePath = NULL;
	if (!PyArg_ParseTuple(args, "s", &pszExePath))
		return NULL;

	// Чж;
	if (!pszExePath || !PathFileExists(pszExePath))
		return Py_BuildValue("b",0);

	// Ƿ;
	_stprintf_s(g_szAppDir, _T("%s"), pszExePath);
	if ( (g_dwAppId = IsAppRunning(g_szAppDir)) != 0)
		return Py_BuildValue("b",1);

	// Ӧó;
	//ShellExecute(NULL, "open", pszExePath, NULL, NULL, SW_SHOWNORMAL);
	SHELLEXECUTEINFO sei;
	memset(&sei, 0, sizeof(SHELLEXECUTEINFO));
	sei.cbSize = sizeof(SHELLEXECUTEINFO);
	sei.hwnd = NULL;
	// ͨ򿪷ʽopenԹԱУrunas
	sei.lpVerb = _T("runas");
	//sei.fMask = SEE_MASK_NOCLOSEPROCESS;//ãʹĬֵ;
	sei.lpFile = g_szAppDir;
	sei.lpParameters = NULL;
	sei.lpDirectory = NULL;
	sei.nShow = SW_SHOWNORMAL;
	sei.hInstApp = NULL;

	if ( !ShellExecuteEx(&sei) )
	{
		DWORD dw = GetLastError();
		return Py_BuildValue("b",0);
	}

	if (sei.hProcess)
		CloseHandle(sei.hProcess);

	// Ϊ0豸;
	// ʵ;

	return Py_BuildValue("b",1);
}

/************************************************************************/
/*  [7/2/2018 Wang];
/*  رս;
/*  ;
/*  أɹ̷1ʧܷ0;
/*  ע⣺Win7ϵͳԹȨУȨӽ̲رս;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
static PyObject* StopApp(PyObject *self, PyObject *args)
{
	// ;
#if 1
	if ( (g_dwAppId = IsAppRunning(g_szAppDir)) != 0)
	{
		if ( !CloseApp(g_dwAppId) )
			return Py_BuildValue("b",0);
	}
#else
	// AppClose;
#endif

	return Py_BuildValue("b",1);	// None;
}

/************************************************************************/
/*  [7/2/2018 Wang];
/*  豸ĬΪ0豸;
/*  ;
/*  	[IN] 豸ֵ0ʼĬֵΪ0;
/*  أvoid;
/*  ע⣺豸ҪӦʱ䣬ԽΪ3;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
static PyObject* ConnectDevice(PyObject *self, PyObject *args)
{
	BOOL bRet = g_ub530.ConnectDevice();
	return Py_BuildValue("b", bRet);
}

/************************************************************************/
/*  [7/2/2018 Wang];
/*  Ͽ豸ĬΪ0豸;
/*  ;
/*  	[IN] 豸ֵ0ʼĬֵΪ0;
/*  أvoid;
/*  ע⣺;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
static PyObject* DisconnectDevice(PyObject *self, PyObject *args)
{
	BOOL bRet = g_ub530.DisconnectDevice();
	return Py_BuildValue("b", bRet);
}

/************************************************************************/
/*  [7/2/2018 Wang];
/*  ʼ/ֹͣ ;
/*  ;
/*  	[IN] trueʼfalseֹͣ;
/*  أvoid;
/*  ע⣺豸ҪӦʱ䣬ԽΪ3;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
static PyObject* StreamOption(PyObject *self, PyObject *args)
{
	BOOL bStartStreaming = FALSE;
	if (!PyArg_ParseTuple(args, "b", &bStartStreaming))
		return NULL;

	BOOL bRet = g_ub530.StreamOpt(bStartStreaming);
	return Py_BuildValue("b", bRet);
}

/************************************************************************/
/*  [7/2/2018 Wang];
/*  ʾ;
/*  ;
/*  	[IN] ;
/*  	[OUT] ;
/*  	[IN/OUT] ;
/*  أvoid;
/*  ע⣺;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
static PyObject* ShowApp(PyObject *self, PyObject *args)
{
	g_ub530.ShowApp();
	return Py_BuildValue("");	// None;
}

/************************************************************************/
/*  [7/2/2018 Wang];
/*  ش;
/*  ;
/*  	[IN] ;
/*  	[OUT] ;
/*  	[IN/OUT] ;
/*  أvoid;
/*  ע⣺;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
static PyObject* HideApp(PyObject *self, PyObject *args)
{
	g_ub530.HideApp();
	return Py_BuildValue("");	// None;
}

/************************************************************************/
/*  [7/2/2018 Wang];
/*  ץͼʽΪλ;
/*  ;
/*  	[IN] 豸0ʼ;
/*  	[IN] ͼƬ·;
/*  	[IN] ͼƬʽĬΪPNG;
/*  	[IN] ݣĬtrue;
/*  	[IN-4] ɼϡ¡4;
/*  	[IN] ͼĬ1;
/*  أvoid;
/*  ע⣺ӿڷصóɹǱɽͼֻǱʾ豸ָӦδɽͼ;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
static PyObject* CaptureImageByCount(PyObject *self, PyObject *args)
{
	// ͼƬʽ;
	unsigned short dwImageType = 3;
	// ;
	BOOL bOverlayMix = TRUE;
	// ɼ;
	int nTop = 0, nLeft = 0, nRight = 0, nBottom = 0;
	// ʱ;
	int nKeepTime = 10;
	// ·;
	const char* lpszSaveDir = NULL;
	// ļǰ׺;
	const char* lpszPrefix = NULL;
	if (!PyArg_ParseTuple(args, "issh", &nKeepTime, &lpszSaveDir, &lpszPrefix, &dwImageType))
		return NULL;

	BOOL bRet = g_ub530.CaptureImageByCount( nKeepTime, lpszSaveDir, lpszPrefix, dwImageType);

	return Py_BuildValue("b", bRet);
}

/************************************************************************/
/*  [7/2/2018 Wang];
/*  ץͼʽΪλ;
/*  ;
/*  	[IN] 豸0ʼ;
/*  	[IN] ͼƬ·;
/*  	[IN] ͼƬʽĬΪPNG;
/*  	[IN] ݣĬtrue;
/*  	[IN-4] ɼϡ¡4;
/*  	[IN] ͼĬ1;
/*  أvoid;
/*  ע⣺;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
static PyObject* CaptureSingleImage(PyObject *self, PyObject *args)
{
	// ͼƬʽ;
	unsigned short dwImageType = 3;
	// ;
	BOOL bOverlayMix = TRUE;
	// ɼ;
	int nTop = 0, nLeft = 0, nRight = 0, nBottom = 0;
	// ʱ;
	int nKeepTime = 10;
	// ·;
	const char* lpszSaveDir = NULL;
	if (!PyArg_ParseTuple(args, "sh", &lpszSaveDir, &dwImageType))
		return NULL;

	BOOL bRet = g_ub530.CaptureSingleImage(lpszSaveDir, dwImageType);

	return Py_BuildValue("b", bRet);
}

/************************************************************************/
/*  [7/2/2018 Wang];
/*  ץͼʽΪλ;
/*  ;
/*  	[IN] 豸0ʼ;
/*  	[IN] ͼƬ·;
/*  	[IN] ͼƬʽĬΪPNG;
/*  	[IN] ݣĬtrue;
/*  	[IN-4] ɼϡ¡4;
/*  	[IN] ʱ䣬Ĭ1000ms;
/*  	[IN] ÿץȡĬ10;
/*  أvoid;
/*  ע⣺;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
static PyObject* CaptureImageByTime(PyObject *self, PyObject *args)
{
	// ͼƬʽ;
	unsigned short dwImageType = 3;
	// ;
	BOOL bOverlayMix = TRUE;
	// ɼ;
	int nTop = 0, nLeft = 0, nRight = 0, nBottom = 0;
	// ʱ;
	int nKeepTime = 10;
	// ÿץȡ;
	int nCaputerCount = 0;
	// ·;
	const char* lpszSaveDir = NULL;
	// ļǰ׺;
	const char* lpszPrefix = NULL;
	if (!PyArg_ParseTuple(args, "iissh", &nKeepTime, &nCaputerCount, &lpszSaveDir, &lpszPrefix, &dwImageType))
		return NULL;

	BOOL bRet = g_ub530.CaptureImageByTime(nKeepTime, nCaputerCount, lpszSaveDir, lpszPrefix, dwImageType);

	return Py_BuildValue("b", bRet);
}

/************************************************************************/
/*  [7/2/2018 Wang];
/*  ֹͣͼδʹ;
/*  ;
/*  	[IN] ;
/*  أvoid;
/*  ע⣺;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
static PyObject* StopCaptureImage(PyObject *self, PyObject *args)
{
	g_ub530.StopCaptureImage();
	return Py_BuildValue("");	// None;
}

/************************************************************************/
/*  [7/2/2018 Wang];
/*  ͬƵ¼;
/*  ;
/*  	[IN] ı·;
/*  	[IN] ¼ʱ䳤ȣΪλԼֵ;
/*  أvoid;
/*  ע⣺;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
static PyObject* StartCaptureAudio(PyObject *self, PyObject *args)
{
	// ·;
	const char* lpszSaveDir = NULL;
	if (!PyArg_ParseTuple(args, "s", &lpszSaveDir))
		return NULL;

	BOOL bRet = g_ub530.SynCaptureAudio(lpszSaveDir);

	return Py_BuildValue("b", bRet);
}

/************************************************************************/
/*  [7/2/2018 Wang];
/*  ֹͣ¼Ƶ;
/*  ;
/*  	[IN] ;
/*  أvoid;
/*  ע⣺;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
static PyObject* StopCaptureAudio(PyObject *self, PyObject *args)
{
	g_ub530.StopCaptureAudio();
	return Py_BuildValue("");	// None;
}

/************************************************************************/
/*  [7/2/2018 Wang];
/*  첽Ƶ¼;
/*  ;
/*  	[IN] ı·;
/*  	[IN] ¼ʱ䳤ȣΪλԼֵ;
/*  أvoid;
/*  ע⣺;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
static PyObject* AsyCaptureAudio(PyObject *self, PyObject *args)
{
	// ʱ;
	DWORD dwKeepTime = 10;
	// ·;
	const char* lpszSaveDir = NULL;
	if (!PyArg_ParseTuple(args, "ls", &dwKeepTime, &lpszSaveDir))
		return NULL;

	BOOL bRet = g_ub530.AsyCaptureAudio(dwKeepTime, lpszSaveDir);

	return Py_BuildValue("b", bRet);
}

/************************************************************************/
/*  [8/13/2018 jianfeng1.wang];
/*  ;
/*  ;
/*  	[IN] ;
/*  	[OUT] ;
/*  	[IN/OUT] ;
/*  أvoid;
/*  ע⣺;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
static PyObject* GetCaptureImageList(PyObject *self, PyObject *args)
{
	// ·;
	const char* lpszImgDir = NULL;
	if (!PyArg_ParseTuple(args, "s", &lpszImgDir))
		return NULL;

	vector<TString> files;
	findfile(lpszImgDir, files);

	if (g_list != NULL)
	{
		Py_DECREF(g_list);
		g_list = NULL;
	}

	int i = 0;
	g_list = PyList_New(0);
	for (vector<TString>::iterator it = files.begin(); it != files.end(); it++)
	{
		PyList_Append(g_list, PyString_FromString(it->c_str()));
	}

	return g_list;
}

// ,¶pythonĺ;
static PyMethodDef UB530_Methods[] ={
	{"IsAppRunning",IsAppRunning,METH_VARARGS,"Ƿ"},
	{"StartApp", StartApp, METH_VARARGS, ""},
	{"StopApp", StopApp, METH_VARARGS, "رս"},
	{"ConnectDevice", ConnectDevice, METH_VARARGS, "豸"},
	{"DisconnectDevice", DisconnectDevice, METH_VARARGS, "Ͽ豸"},
	{"StreamOption",StreamOption,METH_VARARGS,""},
	{"ShowApp", ShowApp, METH_VARARGS, "ʾ"},
	{"HideApp", HideApp, METH_VARARGS, "ش"},
	{"CaptureImageByCount", CaptureImageByCount, METH_VARARGS, "Ϊλץͼ"},
	{"CaptureImageByTime", CaptureImageByTime, METH_VARARGS, "ʱΪλץͼ"},
	{"CaptureSingleImage", CaptureSingleImage, METH_VARARGS, "ץͼ"},
	{"StopCaptureImage", StopCaptureImage, METH_VARARGS, "ֹͣץͼ"},
	{"StartCaptureAudio", StartCaptureAudio, METH_VARARGS, "ͬ¼"},
	{"StopCaptureAudio", StopCaptureAudio, METH_VARARGS, "ͬ¼"},
	{"AsyCaptureAudio", AsyCaptureAudio, METH_VARARGS, "첽¼"},
	{"GetCaptureImageList", GetCaptureImageList, METH_VARARGS, "Ŀ¼ļб"},
	{NULL,NULL}
};

// ʼģ;//ʽinit<ģ>
PyMODINIT_FUNC initUB530SDK()
{
	// ʼڴ;
	g_ub530.InitMemery();
	// Ȩ;
	if ( !GetDebugPriv() )
		WriteTextLog(_T("Ȩʧ"));
	// ʼpydб;
	PyObject *m,*d;
	m = Py_InitModule("UB530SDK", UB530_Methods);
	d = PyModule_GetDict(m);
}


