/************************************************************************/
/*  Copyright (C), 2016-2020, [IT], Ȩ;
/*  ģ  ;
/*      ǰĿݿʵ;
/*
/*      [V];	
/*      ߣ[IT];
/*      ڣ[11/13/2013];
/*
/*
/*  ע    ⣺;
/*
/*  ޸ļ¼[IT];
/*  ޸ڣ;
/*  ޸İ汾;
/*  ޸ݣ;
/************************************************************************/
#ifndef __DATA_IMPL__
#define __DATA_IMPL__

#pragma once
#include "sqlite3.h"
#include <vector>

typedef struct __ST_REPORT__
{
	std::string url;
	std::string content;
	std::string report_date;

	__ST_REPORT__& operator=(const __ST_REPORT__& that)
	{
		if (this != &that )
		{
			url = that.url;
			content = that.content;
			report_date = that.report_date;
		}

		return *this;
	}
}STReport, *pSTReport;

class CDataImpl
{
public:
	CDataImpl(void);
	virtual ~CDataImpl(void);

	// ˽б;
private:
	sqlite3		*m_psqlite3;

	// û;
public:
	BOOL Open();
	void Close();

	// begin;
	int TransactionBegin()
	{
		char* psqlite_error = NULL;
		INT nRet = sqlite3_exec(m_psqlite3, "begin;", 0, 0, &psqlite_error);
		if ( nRet != SQLITE_OK)
		{
			if ( psqlite_error ) 
			{ 
				sqlite3_free(psqlite_error); 
				psqlite_error = NULL;
			}
			return nRet;
		}

		return SQLITE_OK;
	}

	// commit;
	int TransactionCommit()
	{
		char* psqlite_error = NULL;
		INT nRet = sqlite3_exec(m_psqlite3, "commit;", 0, 0, &psqlite_error);
		if ( nRet != SQLITE_OK)
		{
			if ( psqlite_error ) 
			{ 
				sqlite3_free(psqlite_error); 
				psqlite_error = NULL;
			}
			return nRet;
		}
		return SQLITE_OK;
	}

	// ִ;
	BOOL ExecteSQL(IN LPCSTR lpSQL);
	// ѯǷ;
	BOOL QueryTable(std::string table);
	INT QueryReportInfo(std::vector<STReport>& vtdata);
	// ݶŲѯϢ;//زѯ;
	INT QueryUnReportInfo(std::vector<STReport> &vtdata);
	// midϢ;
	INT InsertReportInfo(STReport& data);
	INT InsertReportInfo(std::string url, std::string content, bool report_status =  false);
	// ɾϱɹļ¼1ǰģ;
	INT RemoveReportInfo();

	// ϱ״̬;
	BOOL UpdateKeyReportStatus(STReport& data);
};

#endif