#include "stdafx.h"
#include "MemoryComm.h"
#include "MemoryDef.h"

CMemoryComm::CMemoryComm(void) :m_hLock(NULL),
m_hFileMap(NULL),
m_pMemory(NULL)
{

}

CMemoryComm::~CMemoryComm(void)
{
	Close();
	if (m_hLock != NULL)
	{
		CloseHandle(m_hLock);
	}
}


CMemoryComm::CMemoryComm(const CMemoryComm& other)
{
	//if ( this != other)
	//{
	//	m_hLock = other.m_hLock;
	//	m_hFileMap = other.m_hFileMap;
	//	m_pMemory = other.m_pMemory;
	//}
}

CMemoryComm& CMemoryComm::operator=(const CMemoryComm& other)
{
	// TODO: ڴ˴ return 
	//if (this != other)
	//{
	//	m_hLock = other.m_hLock;
	//	m_hFileMap = other.m_hFileMap;
	//	m_pMemory = other.m_pMemory;
	//}

	return *this;
}


void CMemoryComm::Unmap()
{
	if (m_pMemory)
	{
		::UnmapViewOfFile(m_pMemory);
		m_pMemory = NULL;
	}
}


// ڴ
BOOL CMemoryComm::Lock(DWORD dwTime)
{
	// ûдȴһ
	if (!m_hLock)
	{
		// ʼʱ򲻱κ߳ռ
		m_hLock = ::CreateMutex(NULL, FALSE, MEMERY_NAME);
		if (!m_hLock)
			return FALSE;
	}

	// ĸ߳ȵõȴռ
	DWORD dwRet = ::WaitForSingleObject(m_hLock, dwTime);
	return (dwRet == WAIT_OBJECT_0 || dwRet == WAIT_ABANDONED);
}

void CMemoryComm::Unlock()
{
	if (m_hLock)
	{
		::ReleaseMutex(m_hLock);
	}
}

void CMemoryComm::Close()
{
	Unmap();

	if (m_hFileMap)
	{
		::CloseHandle(m_hFileMap);
		m_hFileMap = NULL;
	}
}

/************************************************************************/
/*  [7/3/2018 Wang];
/*  ʼڴ棬Ѵڴ;
/*  ;
/*  	[IN] ;
/*  	[OUT] ;
/*  	[IN/OUT] ;
/*  أvoid;
/*  ע⣺;
/*  ʾ;
/*
/*  ޸ģ;
/*  ڣ;
/*  ݣ;
/************************************************************************/
BOOL CMemoryComm::InitMemery(DWORD dwOffset /* = 0*/)
{
	if (m_hFileMap == NULL)
	{
		// ڴ;
		m_hFileMap = ::CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, MEMERY_SIZE, MEMERY_NAME);
		if (ERROR_ALREADY_EXISTS == GetLastError())
		{
			CloseHandle(m_hFileMap);
			m_hFileMap = NULL;

			// 򿪹ڴ;
			m_hFileMap = ::OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE, MEMERY_NAME);
			if (!m_hFileMap)
				return FALSE;
		}
	}

	// ڴӳ;
	if (m_pMemory == NULL)
	{
		ULARGE_INTEGER ui;
		ui.QuadPart = static_cast<ULONGLONG>(dwOffset);
		m_pMemory = ::MapViewOfFile(m_hFileMap, FILE_MAP_ALL_ACCESS, ui.HighPart, ui.LowPart, MEMERY_SIZE);
		if (m_pMemory == NULL)
		{
			//ShowSystemErrorInfo(_T("ӳڴʧ"), GetLastError());
			return FALSE;
		}
	}

	return TRUE;
}
